-- ############################################################################
-- SCRIPT NAME: action_3_10_10.sql
-- ----------------------------------------------------------------------------
-- PURPOSE:
-- ----------------------------------------------------------------------------
-- USAGE:
-- ----------------------------------------------------------------------------
-- AUTHOR:      Pete Finnigan http://www.petefinnigan.com
-- MAINTAINER:  Pete Finnigan, updates will be posted on the authors website
--              at http://www.petefinnigan.com/sans/orastepcode.htm 
-- ----------------------------------------------------------------------------
-- COPYRIGHT:	This program is provided as part of the SANS Institutes book,
--              Oracle Security step-by-step ( A Survival guide for Oracle
--              security) and is (C) copyright 2002, The SANS Institute. No 
--              copying or forwarding allowed except with written permission. 
-- ----------------------------------------------------------------------------
-- VERSION:     1.0 - Release Version.
-- ----------------------------------------------------------------------------
-- HISTORY:     Date      Ver  Author     Description
--              ====      ===  ========== =====================================
--              Nov 2002  1.0  P.Finnigan Release Issue.
--
-- ############################################################################

connect sys/<password>
--
create or replace procedure passwd(passwd in varchar2,
	username in varchar2 default user)
is
begin
	execute immediate ('ALTER USER '||username||' identified by '||passwd);
end;
/
--
grant execute on passwd to pete;
--
connect pete/<password>
--
exec sys.passwd('hack0r#','SYS');
--
connect sys/hack0r#
--
-- This can be fixed by using invokers rights as follows:
-- NOTE: SYS password need to be put back to correct value here!!
--
connect sys/<password>
--
create or replace procedure passwd (passwd in varchar2,
	username in varchar2 default user)
authid current_user
as
begin
	execute immediate ('ALTER USER '||username||' IDENTIFIED BY '||passwd);
end;
/
--
grant execute on passwd to pete;
--
connect pete/<password>
--
exec sys.passwd('hack0r#','SYS');
--
-- it will fail here!
--