-- ############################################################################
-- SCRIPT NAME: action_3_22_1.sql
-- ----------------------------------------------------------------------------
-- PURPOSE:
-- ----------------------------------------------------------------------------
-- USAGE:
-- ----------------------------------------------------------------------------
-- AUTHOR:      Pete Finnigan http://www.petefinnigan.com
-- MAINTAINER:  Pete Finnigan, updates will be posted on the authors website
--              at http://www.petefinnigan.com/sans/orastepcode.htm 
-- ----------------------------------------------------------------------------
-- COPYRIGHT:	This program is provided as part of the SANS Institutes book,
--              Oracle Security step-by-step ( A Survival guide for Oracle
--              security) and is (C) copyright 2002, The SANS Institute. No 
--              copying or forwarding allowed except with written permission. 
-- ----------------------------------------------------------------------------
-- VERSION:     1.0 - Release Version.
-- ----------------------------------------------------------------------------
-- HISTORY:     Date      Ver  Author     Description
--              ====      ===  ========== =====================================
--              Nov 2002  1.0  P.Finnigan Release Issue.
--
-- ############################################################################

spool lis.lis 
--
connect sys/<password> as sysdba
--
drop user pete cascade; 
drop user fred cascade; 
--
create user pete identified by <password> 
default tablespace users 
temporary tablespace temp; 
--
grant connect,resource to pete; 
--
grant unlimited tablespace to pete; 
--
create user fred identified by <password>; 
--
grant connect,resource to fred; 
--
connect pete/<password> 
--
create table pete_01 
( 
col_01 number 
); 
--
insert into pete_01(col_01)values(1); 
--
create view pete_view as 
select * 
from pete_01; 
--
grant update on pete_view to fred; 
--
connect fred/<password> 
--
update pete.pete_01 
set col_01=3; 
--
update pete.pete_view 
set col_01=4; 
--
spool off 
--
-- check view permissions granted other than select
--
col grantee for a20
col privilege for a10
col table_name for a30
select grantee,table_name,privilege
from dba_tab_privs
where exists (select 'x'
           from dba_views
           where view_name=table_name)
and privilege<>'SELECT'
union
select grantee,table_name,privilege
from dba_col_privs
where exists (select 'x'
           from dba_views
           where view_name=table_name)
and privilege<>'SELECT'
/
