-- ############################################################################
-- SCRIPT NAME: action_3_5_4.sql
-- ----------------------------------------------------------------------------
-- PURPOSE:
-- ----------------------------------------------------------------------------
-- USAGE:
-- ----------------------------------------------------------------------------
-- AUTHOR:      Pete Finnigan http://www.petefinnigan.com
-- MAINTAINER:  Pete Finnigan, updates will be posted on the authors website
--              at http://www.petefinnigan.com/sans/orastepcode.htm 
-- ----------------------------------------------------------------------------
-- COPYRIGHT:	This program is provided as part of the SANS Institutes book,
--              Oracle Security step-by-step ( A Survival guide for Oracle
--              security) and is (C) copyright 2002, The SANS Institute. No 
--              copying or forwarding allowed except with written permission. 
-- ----------------------------------------------------------------------------
-- VERSION:     1.0 - Release Version.
-- ----------------------------------------------------------------------------
-- HISTORY:     Date      Ver  Author     Description
--              ====      ===  ========== =====================================
--              Nov 2002  1.0  P.Finnigan Release Issue.
--
-- ############################################################################

set serveroutput on size 1000000
declare
	cursor c_role is
 

	select distinct role,granted_role
	from role_role_privs;
	--
	gv_max_level	number:=0;
	gv_level 	number:=0;
	--
	procedure get_child (pv_granted_role in varchar2)
	is
		cursor c_child(cv_granted_role in varchar2) is
		select distinct role,granted_role
		from role_role_privs
		where role=cv_granted_role;
		--
		lv_child c_child%rowtype;
		--
	begin
		open c_child(pv_granted_role);
		fetch c_child into lv_child;
		if c_child%found then
			close c_child;
			gv_level:=gv_level+1;
			get_child(lv_child.granted_role);
		else
			close c_child;
		end if;
	end get_child;
begin
	for lv_role in c_role loop
		gv_level:=1;
		get_child(lv_role.granted_role);
		if gv_level>gv_max_level then
			gv_max_level:=gv_level;
		end if;
	end loop;
	dbms_output.put_line('Max Level is '||gv_max_level);
end;
/
