-- ############################################################################
-- SCRIPT NAME: action_3_8_6.sql
-- ----------------------------------------------------------------------------
-- PURPOSE:
-- ----------------------------------------------------------------------------
-- USAGE:
-- ----------------------------------------------------------------------------
-- AUTHOR:      Pete Finnigan http://www.petefinnigan.com
-- MAINTAINER:  Pete Finnigan, updates will be posted on the authors website
--              at http://www.petefinnigan.com/sans/orastepcode.htm 
-- ----------------------------------------------------------------------------
-- COPYRIGHT:	This program is provided as part of the SANS Institutes book,
--              Oracle Security step-by-step ( A Survival guide for Oracle
--              security) and is (C) copyright 2002, The SANS Institute. No 
--              copying or forwarding allowed except with written permission. 
-- ----------------------------------------------------------------------------
-- VERSION:     1.0 - Release Version.
-- ----------------------------------------------------------------------------
-- HISTORY:     Date      Ver  Author     Description
--              ====      ===  ========== =====================================
--              Nov 2002  1.0  P.Finnigan Release Issue.
--              Oct 2004  1.1  P.Finnigan Fixed quote characters
--
-- ############################################################################

col table_name head "What" for a30
col grantee head "Granted To" for a20
col privilege head "Privilege" for a20

select grantee,'SYSTEM PRIV',privilege
from dba_sys_privs
where grantee not in ('SYSTEM','SYS','PUBLIC')
and not exists (select 'w'
        from dba_roles
        where role=grantee)
union
select grantee,table_name,privilege
from dba_tab_privs
where grantee not in ('SYSTEM','SYS','PUBLIC')
and not exists (select 'w'
        from dba_roles
        where role=grantee)
union
select grantee,table_name,privilege
from dba_col_privs
where grantee not in ('SYSTEM','SYS','PUBLIC')
and not exists (select 'w'
        from dba_roles
        where role=grantee)
/
