-- ############################################################################
-- SCRIPT NAME: action_5_7_3.sql
-- ----------------------------------------------------------------------------
-- PURPOSE:
-- ----------------------------------------------------------------------------
-- USAGE:
-- ----------------------------------------------------------------------------
-- AUTHOR:      Pete Finnigan http://www.petefinnigan.com
-- MAINTAINER:  Pete Finnigan, updates will be posted on the authors website
--              at http://www.petefinnigan.com/sans/orastepcode.htm 
-- ----------------------------------------------------------------------------
-- COPYRIGHT:	This program is provided as part of the SANS Institutes book,
--              Oracle Security step-by-step ( A Survival guide for Oracle
--              security) and is (C) copyright 2002, The SANS Institute. No 
--              copying or forwarding allowed except with written permission. 
-- ----------------------------------------------------------------------------
-- VERSION:     1.0 - Release Version.
-- ----------------------------------------------------------------------------
-- HISTORY:     Date      Ver  Author     Description
--              ====      ===  ========== =====================================
--              Nov 2002  1.0  P.Finnigan Release Issue.
--
-- ############################################################################

drop table aud_login
/
create table aud_login
(
	username	varchar2(30) not null,
	login_date	date not null,
	osuser		varchar2(30),
	machine		varchar2(64),
	program		varchar2(64)
) tablespace tools
/

create or replace trigger check_login
after logon on database
declare
	--
	pragma autonomous_transaction;
	lv_username	aud_login.username%type;
	lv_osuser	aud_login.osuser%type;
	lv_machine	aud_login.machine%type;
	lv_program	aud_login.program%type;
	lv_stmnt	varchar2(2000);
	--
begin
	lv_username:=upper(sys_context('userenv','session_user'));
	lv_stmnt:='insert into aud_login(username,login_date,osuser,machine,program)';
	lv_stmnt:=lv_stmnt||' values(:1,:2,:3,:4,:5)';
	begin
		select 	s.osuser,
			s.machine,
			s.program
		into	lv_osuser,
			lv_machine,
			lv_program
		from	v$session s
		where	sys_context('userenv','SESSIONID')=s.audsid;
		execute immediate lv_stmnt using lv_username,sysdate,lv_osuser,
			lv_machine,lv_program;
		commit;
	exception
		when others then
			null;
	end;
end;
/
